/***************************************************************************
        engineobject.h  -  baseclass for most Chessterfield objects
                             -------------------
    begin                : Sat Jun 3 2000
    copyright            : (C) 1996-2001 by Matthias Luescher
    email                : m.luescher@datacomm.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


class Piece;
class King;
class NodeStack;
class GameHistory;
class HashTable;
 
class EngineObject
{
public:
	EngineObject();

	static Move m_move;
	static GameHistory* m_gameHistory;
	static HashTable* m_hash;
	static Piece* m_board[65];
	static Piece *m_pieceList[33];
	static int m_epSquare;
	static NodeStack* m_currentStack;
	static Move* m_moveStack;
	static bool m_staticInitDone;
	static King* m_pKing[2]; //[WHITE], [BLACK] 

	// evaluation parameters
	static bool m_pawnEndgame; // no queen or rook on board
	static int m_drawValue;
	static int m_positionType; 
	static int m_wPawnColumns[10];
	static int m_bPawnColumns[10];
	const static int m_initPawnColumns[10];
	static bool m_kingFields1[64];
	static bool m_kingFields2[64];
	static bool* m_owKingFields;
	static bool* m_opKingFields;
protected:
	void DeallocateStaticMembers();
	bool DoPGNMove(int from_r, int from_c, int to_r, 
				   int to_c, int piece, int p_piece );
	void popMove();
	void DeleteAllPieces();
	void undoCastling();
	bool IsValidMove();
	int pushMove();
};



