/***************************************************************************
           learnobject.h  -  does the learning of games and endgames
                             -------------------
    begin                : Sat Jun 3 2000
    copyright            : (C) 1996-2001 by Matthias Luescher
    email                : m.luescher@datacomm.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string>

using namespace std;

typedef vector<int> INTVECTOR;
typedef INTVECTOR::iterator IntVectorIt;
 
class LearnObject:public EngineObject
{
public:
	LearnObject();
	~LearnObject();
	bool LoadTrainingSet(string filename, int filter);
	void ProcessPGNFile(PGNFile* f);
	void WeightFitting();
	void PGNWeightFitting();
	void WDLStatistics();
	void PGNStatistics();
	void HalfmoveStatistics(string filename, int filter, int sampling);
	bool HalfmoveSearch(int &eSuccessCount, int &rSuccessCount, int value);
	bool GetPositionValueFromDB(int &value);
	void GenerateConfigurations(int maxA);
	void GeneratePGNConfigurations();
	void OptimizeConfigurationSet();
private:
	bool FilterPosition(INTVECTOR* pieces, int value, bool toPlay, int filter);
	void AddCurrentPositionToSet(int value, bool toPlay);
	void LoadPosition(INTVECTOR* pieces, bool toPlay);
	int GeneratePieceConfigurations(int piece, unsigned int bitcode, int nextbit, 
									int maxA, unsigned int not_msac);
	bool IsValidConfiguration(int piece, unsigned int bitcode, int minCt, int maxIt);
	PositionSet m_setList[MAX_POSITIONTYPES];
	PositionSet* m_currentSet;
	Evaluation m_evaluator;
};



