/***************************************************************************
     listclasses.h  -  classes for move history and temporary move stacks
                             -------------------
    begin                : Sat Jun 3 2000
    copyright            : (C) 1996-2001 by Matthias Luescher
    email                : m.luescher@datacomm.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

class GameHistory
{
public:
	void GetRedoMove(Move* move) {
		move->sq1 = m_zugList[m_nMoves].sq1;
		move->sq2 = m_zugList[m_nMoves].sq2;
		move->special = m_zugList[m_nMoves].special;
		move->value = 0;
		move->remark = VERIFY_MOVE;
		move->o_value = 0;};
	ExtendedMove* GetElementNr(int nr) {return &m_zugList[nr];};
	ExtendedMove* GetTail() {return &m_zugList[m_nMoves - 1];};
	int GetCount() {return m_nMoves;};
	void RemoveElement(){m_nMoves--;};
	ExtendedMove* AddElement(){
		m_nMoves++;
		return (&(m_zugList[m_nMoves - 1]));};
	GameHistory() {m_nMoves = 0;};
private:
	int m_nMoves;
	ExtendedMove m_zugList[MAX_NR_OF_MOVES + MAX_SEARCH_DEPTH + 1];
};

class NodeStack
{
public:
	void BestOrientation();
	Move* GetNextBest();
	NodeStack(Move* pTail) {m_pTail = pTail; m_nMoves = 0;};
	~NodeStack() {};
	void Clear() {m_pTail -= m_nMoves; m_nMoves = 0;};
	Move* GetTail() const {return m_pTail;};
	void AddElement(Move* pMove)
	{pMove->valid = true; *m_pTail = *pMove; m_nMoves++; m_pTail++;};
	Move* GetTail(){return m_pTail;};
	int Size() { return m_nMoves; };
private:
	Move* m_pTail;
	int m_nMoves;
};

