/***************************************************************************
          pieces.cpp  -  all the pieces with their special behaviour
                             -------------------
    begin                : Sat Jun 3 2000
    copyright            : (C) 1996-2001 by Matthias Luescher
    email                : m.luescher@datacomm.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <cassert>

#include "def_inc.h"
#include "engineobject.h"
#include "listclasses.h"
#include "pieces.h"


//----------------------------------------------------------------------------
//		static member variables
//----------------------------------------------------------------------------

const int tDown[120] = //NO_SQUARE is written as 64!
	{64,64,64,64,64,64,64,64,64,64,
	 64,64,64,64,64,64,64,64,64,64,
	 64, 0, 1, 2, 3, 4, 5, 6, 7,64,
	 64, 8, 9,10,11,12,13,14,15,64,
	 64,16,17,18,19,20,21,22,23,64,
	 64,24,25,26,27,28,29,30,31,64,
	 64,32,33,34,35,36,37,38,39,64,
	 64,40,41,42,43,44,45,46,47,64,
	 64,48,49,50,51,52,53,54,55,64,
	 64,56,57,58,59,60,61,62,63,64,
	 64,64,64,64,64,64,64,64,64,64,
	 64,64,64,64,64,64,64,64,64,64};

const int tUp[65] = 
	{21,22,23,24,25,26,27,28,
	 31,32,33,34,35,36,37,38,
	 41,42,43,44,45,46,47,48,
	 51,52,53,54,55,56,57,58,
	 61,62,63,64,65,66,67,68,
	 71,72,73,74,75,76,77,78,
	 81,82,83,84,85,86,87,88,
	 91,92,93,94,95,96,97,98,0};

//const unsigned int kbnkRegionsBB[64] = { // Bit 17-20 und 28-31
//	BIT_17, BIT_17, BIT_18, BIT_19, BIT_29, BIT_29, BIT_20, BIT_20, 
//	BIT_17, BIT_18, BIT_19, BIT_28, BIT_28, BIT_28, BIT_28, BIT_20, 
//	BIT_18, BIT_19, BIT_19, BIT_30, BIT_30, BIT_30, BIT_28, BIT_29, 
//	BIT_19, BIT_28, BIT_30, BIT_31, BIT_31, BIT_30, BIT_28, BIT_29, 
//	BIT_29, BIT_28, BIT_30, BIT_31, BIT_31, BIT_30, BIT_28, BIT_19, 
//	BIT_29, BIT_28, BIT_30, BIT_30, BIT_30, BIT_19, BIT_19, BIT_18, 
//	BIT_20, BIT_28, BIT_28, BIT_28, BIT_28, BIT_19, BIT_18, BIT_17, 
//	BIT_20, BIT_20, BIT_29, BIT_29, BIT_19, BIT_18, BIT_17, BIT_17 };


//const unsigned int kbnkRegionsBB[64] = { // Bit 17-20 und 28-31
//	BIT_17, BIT_17, BIT_18, BIT_19, BIT_20, BIT_28, BIT_29, BIT_30, 
//	BIT_17, BIT_18, BIT_19, BIT_20, BIT_28, BIT_29, BIT_30, BIT_29, 
//	BIT_18, BIT_19, BIT_20, BIT_28, BIT_29, BIT_30, BIT_29, BIT_28, 
//	BIT_19, BIT_20, BIT_28, BIT_31, BIT_31, BIT_29, BIT_28, BIT_20, 
//	BIT_20, BIT_28, BIT_29, BIT_31, BIT_31, BIT_28, BIT_20, BIT_19, 
//	BIT_28, BIT_29, BIT_30, BIT_29, BIT_28, BIT_20, BIT_19, BIT_18, 
//	BIT_29, BIT_30, BIT_29, BIT_28, BIT_20, BIT_19, BIT_18, BIT_17, 
//	BIT_30, BIT_29, BIT_28, BIT_20, BIT_19, BIT_18, BIT_17, BIT_17 };

const unsigned int cornerDistance[64] = {
	BIT_19, BIT_19, BIT_17, BIT_18, BIT_18, BIT_17, BIT_19, BIT_19, 
	BIT_19, BIT_19, BIT_17, BIT_18, BIT_18, BIT_17, BIT_19, BIT_19, 
	BIT_17, BIT_17, BIT_17, BIT_18, BIT_18, BIT_17, BIT_17, BIT_17, 
	BIT_18, BIT_18, BIT_18, BIT_18, BIT_18, BIT_18, BIT_18, BIT_18, 
	BIT_18, BIT_18, BIT_18, BIT_18, BIT_18, BIT_18, BIT_18, BIT_18, 
	BIT_17, BIT_17, BIT_17, BIT_18, BIT_18, BIT_17, BIT_17, BIT_17, 
	BIT_19, BIT_19, BIT_17, BIT_18, BIT_18, BIT_17, BIT_19, BIT_19, 
	BIT_19, BIT_19, BIT_17, BIT_18, BIT_18, BIT_17, BIT_19, BIT_19 };
	
const unsigned int centerDistance[64] = {
	BIT_31, BIT_31, BIT_30, BIT_29, BIT_29, BIT_30, BIT_31, BIT_31, 
	BIT_31, BIT_30, BIT_29, BIT_28, BIT_28, BIT_29, BIT_30, BIT_31, 
	BIT_30, BIT_29, BIT_28, BIT_27, BIT_27, BIT_28, BIT_29, BIT_30, 
	BIT_29, BIT_28, BIT_27, BIT_26, BIT_26, BIT_27, BIT_28, BIT_29, 
	BIT_29, BIT_28, BIT_27, BIT_26, BIT_26, BIT_27, BIT_28, BIT_29, 
	BIT_30, BIT_29, BIT_28, BIT_27, BIT_27, BIT_28, BIT_29, BIT_30, 
	BIT_31, BIT_30, BIT_29, BIT_28, BIT_28, BIT_29, BIT_30, BIT_31, 
	BIT_31, BIT_31, BIT_30, BIT_29, BIT_29, BIT_30, BIT_31, BIT_31 };


// KBNK patch
//const unsigned int kbnkRow[64] = {
//	BIT_2 , BIT_3 , BIT_6 , BIT_7 , BIT_9 , BIT_10, BIT_13, BIT_14,
//	BIT_3 , BIT_6 , BIT_7 , BIT_9 , BIT_10, BIT_13, BIT_14, BIT_13,
//	BIT_6 , BIT_7 , BIT_9 , BIT_10, BIT_13, BIT_14, BIT_13, BIT_10,
//	BIT_7 , BIT_9 , BIT_10, BIT_13, BIT_14, BIT_13, BIT_10, BIT_9 ,
//	BIT_9 , BIT_10, BIT_13, BIT_14, BIT_13, BIT_10, BIT_9 , BIT_7 ,
//	BIT_10, BIT_13, BIT_14, BIT_13, BIT_10, BIT_9 , BIT_7 , BIT_6 ,
//	BIT_13, BIT_14, BIT_13, BIT_10, BIT_9 , BIT_7 , BIT_6 , BIT_3 ,
//	BIT_14, BIT_13, BIT_10, BIT_9 , BIT_7 , BIT_6 , BIT_3 , BIT_2  };
//const unsigned int kbnkColumn[64] = {
//	BIT_17, BIT_17, BIT_17, BIT_17, BIT_18, BIT_18, BIT_18, BIT_18, 
//	BIT_17, BIT_19, BIT_19, BIT_19, BIT_20, BIT_20, BIT_20, BIT_18, 
//	BIT_17, BIT_19, BIT_28, BIT_28, BIT_29, BIT_29, BIT_20, BIT_18, 
//	BIT_17, BIT_19, BIT_28, BIT_30, BIT_30, BIT_29, BIT_20, BIT_18, 
//	BIT_18, BIT_20, BIT_29, BIT_30, BIT_30, BIT_28, BIT_19, BIT_17, 
//	BIT_18, BIT_20, BIT_29, BIT_29, BIT_28, BIT_28, BIT_19, BIT_17, 
//	BIT_18, BIT_20, BIT_20, BIT_20, BIT_19, BIT_19, BIT_19, BIT_17, 
//	BIT_18, BIT_18, BIT_18, BIT_18, BIT_17, BIT_17, BIT_17, BIT_17 };


// possible moves (array of relative distance between two squares)
const int pieceMoves[2] = {NO_SQUARE,NO_SQUARE};
const int wPawnMoves[4] = {9, 11, 8, NO_SQUARE};
const int bPawnMoves[4] = {-9, -11, -8, NO_SQUARE};
const int knightMoves[9] = {-8, -12, -19, -21, 8, 12, 19, 21, NO_SQUARE};
const int bishopMoves[5] = {9, 11, -9, -11, NO_SQUARE};
const int rookMoves[5] = {1, -1, 10, -10, NO_SQUARE};
const int queenMoves[9] = {9, 11, -9, -11, 1, -1, 10, -10, NO_SQUARE};
const int kingMoves[9] = { 1, 9, 10, 11, -1, -9, -10, -11, NO_SQUARE};

//----------------------------------------------------------------------------
//		BASECLASS
//----------------------------------------------------------------------------

Piece::Piece(int _color, int _square, int _number, Piece* copy )
{
	hashtype = 12;
	init(_color, _square, _number, copy);

	possibleMoves = pieceMoves;
	type = NO_PIECE;
	value = 0;
	drawValue = DRAW_VALUE_NO_PIECE;
}

void Piece::init(int _color, int _square, int _number, Piece* copy)
{
	if ( copy == NULL )
	{
		color = _color;
		moveCount = 0;
		number = _number;
		square = _square;
	}
	else
	{
		color = copy->color;
		moveCount = copy->moveCount;

		number = copy->number;
		square = copy->square;
		next = copy->next;
		previous = copy->previous;
		previous->next = this;
		next->previous = this;
			
		memcpy(bonus, copy->bonus, 64 * sizeof(int));
	}

	if ( color == WHITE )
		hashtype += 6;

	m_pieceList[number] = this;
	m_board[square] = this;

	if ( copy == NULL )
	{
		if ( square != NO_SQUARE )
		{
			switch( _number )
			{
			case 32:
				next = this;
				previous = this;
				break;
			case 31: //Koenig schwarz
				next = this;
				previous = this;
				break;
			case 15: //Koenig weiss
				next = this;
				previous = this;
				break;
			default:
				previous = m_pieceList[_number + 1]->previous;
				next = m_pieceList[_number + 1];
				next->previous = this;
				previous->next = this;
				break;
			}
		}
		else
		{
			next = this;
			previous = this;
		}
	}
}

bool Piece::onKingsLine()
{
	m_move.sq1 = square;
	m_move.sq2 = m_pKing[color]->square;

	if ( (square & 7) == ( m_move.sq2 & 7) || square >> 3 == m_move.sq2 >> 3 )
		straight();
	else
		diagonal();

	if ( m_move.special == IN_LINE )
	{
	Piece* pBackup = m_board[square];
	Piece* p;
		m_board[square] = m_pieceList[32];

		p = m_pKing[!color]->next;

		while( p->type != KING )
		{
			if ( p->type == BISHOP ||
				 p->type == ROOK || p->type == QUEEN )
			{
				m_move.sq1 = p->square;
				p->verifyMove();
				if ( m_move.valid ) 
				{
					m_board[square] = pBackup;
					return true;
				}	
			}
			p = p->next;
		}

		m_board[square] = pBackup;
	}
	return false;
}

int Piece::generateMoves()
{
int count = 0;
const int* direction = possibleMoves;
	m_move.sq1 = square;
	m_move.sq2 = square;
	m_move.special = NOTHING;

	do
	{
		m_move.sq2 = tDown[tUp[m_move.sq2] + (*direction)];

		if ( m_move.sq2 != NO_SQUARE ) 
		{
			if ( m_board[m_move.sq2] == m_pieceList[32] ) 
			{
				m_currentStack->AddElement(&m_move);
				count++;
			}
			else if ( m_board[m_move.sq2]->color != color ) 
			{
				m_currentStack->AddElement(&m_move);
				direction++;
				m_move.sq2 = square;
				count++;
			}
			else 
			{
				direction++;
				m_move.sq2 = square;
			}
		}
		else
		{
			direction++;
			m_move.sq2 = square;
		}
	} while ( (*direction) != NO_SQUARE );

	return count;
}

void Piece::generateXMoves()
{
	m_move.sq1 = square;
	const int* vs = possibleMoves;
	m_move.sq2 = square;
	
	while ( (*vs) != NO_SQUARE )
	{
		m_move.sq2 = tDown[tUp[m_move.sq2] + (*vs)];

		if ( m_move.sq2 != NO_SQUARE ) 
		{
			if ( m_board[m_move.sq2]->color == color ) 
			{
				vs++;
				m_move.sq2 = square;
			}
			else if ( m_board[m_move.sq2] != m_pieceList[32] )
			{
				m_move.special = NOTHING;
				m_move.valid = true;
				m_move.o_value = m_board[m_move.sq2]->value - value;
				m_currentStack->AddElement(&m_move);
				vs++;
				m_move.sq2 = square;
			}			
		}
		else 
		{
			vs++;
			m_move.sq2 = square;
		}
	}
}

void Piece::verifyMove()
{
	m_move.special = NOTHING;
	m_move.valid = false;
}

bool Piece::isAttacked()
{
Piece* p = m_pKing[!color];
Move moveBackup = m_move; 

	m_move.sq2 = square;
	m_move.valid = false;

	do
	{
		m_move.sq1 = p->square;
		switch ( square - m_move.sq1 )
		{
		case 7:  p->verifyMove(); break;
		case -7: p->verifyMove(); break;
		case 9:  p->verifyMove(); break;
		case -9: p->verifyMove(); break;
		default: 
			if ( p->type != PAWN ) p->verifyMove(); break;
		}

		if ( m_move.valid ) 
		{
			m_move = moveBackup;
			return true;
		}
		p = p->next;
	} while ( p->type != KING );

	m_move = moveBackup;
	return false;
}

void Piece::diagonal()
{
	m_move.valid = false;

	if ( ((square + (square >> 3)) & 1) != ((m_move.sq2 + (m_move.sq2 >> 3)) & 1) )
	{
		return;
	}
	else
	{
		switch( m_move.sq2 - square )
		{
			case 63: if ( m_board[square + 54] != m_pieceList[32] ) return;
			case 54: if ( m_board[square + 45] != m_pieceList[32] ) return;
			case 45: if ( m_board[square + 36] != m_pieceList[32] ) return;
			case 36: if ( m_board[square + 27] != m_pieceList[32] ) return;
			case 27: if ( m_board[square + 18] != m_pieceList[32] ) return;
			case 18: if ( m_board[square + 9] != m_pieceList[32] ) return;
			case 9: break;

			case -63: if ( m_board[square - 54] != m_pieceList[32] ) return;
			case -54: if ( m_board[square - 45] != m_pieceList[32] ) return;
			case -45: if ( m_board[square - 36] != m_pieceList[32] ) return;
			case -36: if ( m_board[square - 27] != m_pieceList[32] ) return;
			case -27: if ( m_board[square - 18] != m_pieceList[32] ) return;
			case -18: if ( m_board[square - 9] != m_pieceList[32] ) return;
			case -9: break;

			case 49: if ( m_board[square + 42] != m_pieceList[32] ) return;
			case 42: if ( m_board[square + 35] != m_pieceList[32] ) return;
			case 35: if ( m_board[square + 28] != m_pieceList[32] ) return;
			case 28: if ( m_board[square + 21] != m_pieceList[32] ) return;
			case 21: if ( m_board[square + 14] != m_pieceList[32] ) return;
			case 14: if ( m_board[square + 7] != m_pieceList[32] ) return;
			case 7: break;


			case -49: if ( m_board[square - 42] != m_pieceList[32] ) return;
			case -42: if ( m_board[square - 35] != m_pieceList[32] ) return;
			case -35: if ( m_board[square - 28] != m_pieceList[32] ) return;
			case -28: if ( m_board[square - 21] != m_pieceList[32] ) return;
			case -21: if ( m_board[square - 14] != m_pieceList[32] ) return;
			case -14: if ( m_board[square - 7] != m_pieceList[32] ) return;
			case -7: break;

			default: return;
		}

		if ( m_board[m_move.sq2]->color == color )
		{
			m_move.valid = false;
			m_move.special = IN_LINE;
		}
		else
			m_move.valid = true;
	}
}

void Piece::straight()
{
	m_move.valid = false;

	if ( (square & 7) != (m_move.sq2 & 7) && square >> 3 !=  m_move.sq2 >> 3 )
	{
		return;
	}
	else
	{
		switch( m_move.sq2 - square )
		{
			case 7: if ( m_board[square + 6] != m_pieceList[32] ) return;
			case 6: if ( m_board[square + 5] != m_pieceList[32] ) return;
			case 5: if ( m_board[square + 4] != m_pieceList[32] ) return;
			case 4: if ( m_board[square + 3] != m_pieceList[32] ) return;
			case 3: if ( m_board[square + 2] != m_pieceList[32] ) return;
			case 2: if ( m_board[square + 1] != m_pieceList[32] ) return;
			case 1: break;

			case -7: if ( m_board[square - 6] != m_pieceList[32] ) return;
			case -6: if ( m_board[square - 5] != m_pieceList[32] ) return;
			case -5: if ( m_board[square - 4] != m_pieceList[32] ) return;
			case -4: if ( m_board[square - 3] != m_pieceList[32] ) return;
			case -3: if ( m_board[square - 2] != m_pieceList[32] ) return;
			case -2: if ( m_board[square - 1] != m_pieceList[32] ) return;
			case -1: break;

			case 56: if ( m_board[square + 48] != m_pieceList[32] ) return;
			case 48: if ( m_board[square + 40] != m_pieceList[32] ) return;
			case 40: if ( m_board[square + 32] != m_pieceList[32] ) return;
			case 32: if ( m_board[square + 24] != m_pieceList[32] ) return;
			case 24: if ( m_board[square + 16] != m_pieceList[32] ) return;
			case 16: if ( m_board[square + 8] != m_pieceList[32] ) return;
			case 8: break;

			case -56: if ( m_board[square - 48] != m_pieceList[32] ) return;
			case -48: if ( m_board[square - 40] != m_pieceList[32] ) return;
			case -40: if ( m_board[square - 32] != m_pieceList[32] ) return;
			case -32: if ( m_board[square - 24] != m_pieceList[32] ) return;
			case -24: if ( m_board[square - 16] != m_pieceList[32] ) return;
			case -16: if ( m_board[square - 8] != m_pieceList[32] ) return;
			case -8: break;

			default: return;
		}

		if ( m_board[m_move.sq2]->color == color )
		{
			m_move.valid = false;
			m_move.special = IN_LINE;
		}
		else
			m_move.valid = true;
	}
}

//----------------------------------------------------------------------------
//		PAWN, white and black
//----------------------------------------------------------------------------

WPawn::WPawn(int _color, int _square, int _number, Piece* copy)
{
	hashtype = 0;
	init(_color, _square, _number, copy);

	possibleMoves = wPawnMoves;
	type = PAWN;

	value = Q_PAWN;
	drawValue = DRAW_VALUE_PAWN;
}

BPawn::BPawn(int _color, int _square, int _number, Piece* copy)
{
	hashtype = 0;
	init(_color, _square, _number, copy);

	possibleMoves = bPawnMoves;
	type = PAWN;
	value = Q_PAWN;
	drawValue = DRAW_VALUE_PAWN;
}

void WPawn::verifyMove()
{
int sq2 = m_move.sq2;
Piece* piece2 = m_board[sq2];
	m_move.valid = false;
	m_move.special = NOTHING;

	switch(sq2 - square)
	{
		case 7:
			if ( (square & 7) == 0 || piece2->color == WHITE ) return;

			if ( piece2->color == BLACK )
			{
				m_move.valid = true;
				if ( sq2 >> 3 == 7 ) m_move.special = NEW_QUEEN;
			}
			else if ( sq2 == m_epSquare )
			{
				m_move.special = EN_PASSANT;
				m_move.valid = true;
			}
			break;
		case 8:
			if ( piece2 == m_pieceList[32] )
			{
				m_move.valid = true; 
				if ( sq2 >> 3 == 7 ) m_move.special = NEW_QUEEN;
			}
			break;
		case 9:
			if ( (square & 7) == 7 || piece2->color == WHITE ) return;
			
			if ( piece2->color == BLACK )
			{
				m_move.valid = true;
				if ( sq2 >> 3 == 7 ) m_move.special = NEW_QUEEN;
			}
			else if ( sq2 == m_epSquare )
			{
				m_move.special = EN_PASSANT;
				m_move.valid = true;
			}
			break;
		case 16:
			if ( m_board[square + 8] == m_pieceList[32] && piece2 == m_pieceList[32] &&
				  square >> 3 == 1)
			{
				m_move.valid = true; 
				m_move.special = DOUBLE_ADVANCE;
			}
			break;
	}
}

void BPawn::verifyMove()
{
int sq2 = m_move.sq2;
Piece* piece2 = m_board[sq2];
	m_move.valid = false;
	m_move.special = NOTHING;

	switch(sq2 - square)
	{
		case -7:
			if ( (square & 7) == 7 || piece2->color == BLACK ) return;
			
			if ( piece2->color == WHITE )
			{
				m_move.valid = true;
				if ( sq2 >> 3 == 0 ) m_move.special = NEW_QUEEN;
			}
			else if ( sq2 == m_epSquare )
			{
				m_move.special = EN_PASSANT;
				m_move.valid = true;
			}
			break;
		case -8:
			if ( piece2 == m_pieceList[32] )
			{
				m_move.valid = true; 
				if ( sq2 >> 3 == 0 ) m_move.special = NEW_QUEEN;
			}
			break;
		case -9:
			if ( (square & 7) == 0 || piece2->color == BLACK ) return;
			
			if ( piece2->color == WHITE )
			{
				m_move.valid = true;
				if ( sq2 >> 3 == 0 ) m_move.special = NEW_QUEEN;
			}
			else if ( sq2 == m_epSquare )
			{
				m_move.special = EN_PASSANT;
				m_move.valid = true;
			}
			break;
		case -16:
			if ( m_board[square - 8] == m_pieceList[32] && piece2 == m_pieceList[32] &&
				 square >> 3 == 6 )
			{
				m_move.valid = true;
				m_move.special = DOUBLE_ADVANCE;
			}
			break;
	}
}

int BPawn::generateMoves()
{
int count = 0;
	m_move.sq1 = square;

	if ( (square & 7) != 7 ) // square - 7							
	{
		m_move.sq2 = square - 7;	
		if ( m_board[square - 7]->color == WHITE )	
		{
			if ( square >> 3 == 1 ) 
			{
				count += promotion();
			}
			else
			{
				m_move.special = NOTHING;
				m_currentStack->AddElement(&m_move);
				count++;	
			}
		}
		else if ( m_board[square - 7] == m_pieceList[32] )
		{
			if ( m_move.sq2 == m_epSquare )
			{
				m_move.special = EN_PASSANT; 
				m_currentStack->AddElement(&m_move);
				count++;	
			}
		}
	}
	
	if ( (square & 7) != 0 ) // square - 9
	{
		m_move.sq2 = square - 9;

		if ( m_board[square - 9]->color == WHITE )
		{
			if ( square >> 3 == 1 ) 
			{
				count += promotion();
			}
			else
			{
				m_move.special = NOTHING;
				m_currentStack->AddElement(&m_move);
				count++;
			}
		}
		else if ( m_board[square - 9] == m_pieceList[32] )
		{
			if ( m_move.sq2 == m_epSquare )
			{
				m_move.special = EN_PASSANT; 
				m_currentStack->AddElement(&m_move);
				count++;	
			}
		}
	}
	
	if ( m_board[square - 8] == m_pieceList[32] ) // square - 8
	{
		m_move.sq2 = square - 8;

		if ( square >> 3 == 1 ) 
		{
			count += promotion();
		}
		else
		{
			m_move.special = NOTHING;
			m_currentStack->AddElement(&m_move);
			count++;	
		}
	}

	if ( m_board[square - 8] == m_pieceList[32] && m_board[square - 16] == m_pieceList[32] && // square - 16
		  square >> 3 == 6)
	{
		m_move.sq2 = square - 16;
		m_move.special = DOUBLE_ADVANCE;
		m_currentStack->AddElement(&m_move);
		count++;	
	}

	return count;
}

void BPawn::generateXMoves()
{
	m_move.sq1 = square;

	if ( (square & 7) != 7 && m_board[square - 7]->color == WHITE )
	{
		m_move.sq2 = square - 7;
		if ( square >> 3 == 1 ) m_move.special = NEW_QUEEN;
		else m_move.special = NOTHING;
		m_move.o_value =  m_board[m_move.sq2]->value - Q_PAWN;
		m_move.valid = true;
		m_currentStack->AddElement(&m_move);
	}

	if ( (square & 7) != 0 && m_board[square - 9]->color == WHITE )
	{
		m_move.sq2 = square - 9;
		if ( square >> 3 == 1 ) m_move.special = NEW_QUEEN;
		else m_move.special = NOTHING;
		m_move.o_value =  m_board[m_move.sq2]->value - Q_PAWN;
		m_move.valid = true;
		m_currentStack->AddElement(&m_move);
	}

	if ( square >> 3 == 1 && m_board[square - 8] == m_pieceList[32] )
	{
		m_move.sq2 = square - 8;
		m_move.special = NEW_QUEEN;
		m_move.valid = true;
		m_move.o_value =  Q_QUEEN - Q_PAWN;
		m_currentStack->AddElement(&m_move);
	}
}

int WPawn::generateMoves()
{
int count = 0;
	m_move.sq1 = square;

	if ( (square & 7) != 0 ) // square + 7							
	{
		m_move.sq2 = square + 7;	
		if ( m_board[square + 7]->color == BLACK )	
		{
			if ( square >> 3 == 6 ) 
			{
				count += promotion();
			}
			else
			{
				m_move.special = NOTHING;
				m_currentStack->AddElement(&m_move);
				count++;	
			}
		}
		else if ( m_board[square + 7] == m_pieceList[32] )
		{
			if ( m_move.sq2 == m_epSquare )
			{
				m_move.special = EN_PASSANT; 
				m_currentStack->AddElement(&m_move);
				count++;	
			}
		}
	}
	
	if ( (square & 7) != 7 ) // square + 9
	{
		m_move.sq2 = square + 9;

		if ( m_board[square + 9]->color == BLACK )
		{
			if ( square >> 3 == 6 ) 
			{
				count += promotion();
			}
			else
			{
				m_move.special = NOTHING;
				m_currentStack->AddElement(&m_move);
				count++;
			}
		}
		else if ( m_board[square + 9] == m_pieceList[32] )
		{
			if ( m_move.sq2 == m_epSquare )
			{
				m_move.special = EN_PASSANT; 
				m_currentStack->AddElement(&m_move);
				count++;	
			}
		}
	}
	
	if ( m_board[square + 8] == m_pieceList[32] ) // square + 8
	{
		m_move.sq2 = square + 8;

		if ( square >> 3 == 6 ) 
		{
			count += promotion();
		}
		else
		{
			m_move.special = NOTHING;
			m_currentStack->AddElement(&m_move);
			count++;	
		}
	}

	if ( m_board[square + 8] == m_pieceList[32] && m_board[square + 16] == m_pieceList[32] && // square + 16
		  square >> 3 == 1)
	{
		m_move.sq2 = square + 16;
		m_move.special = DOUBLE_ADVANCE;
		m_currentStack->AddElement(&m_move);
		count++;	
	}

	return count;
}

void WPawn::generateXMoves()
{
	m_move.sq1 = square;

	if ( (square & 7) != 0 && m_board[square + 7]->color == BLACK )
	{
		m_move.sq2 = square + 7;
		if ( square >> 3 == 6 ) m_move.special = NEW_QUEEN;
		else m_move.special = NOTHING;
		m_move.o_value =  m_board[m_move.sq2]->value - Q_PAWN;
		m_move.valid = true;
		m_currentStack->AddElement(&m_move);
	}

	if ( (square & 7) != 7 && m_board[square + 9]->color == BLACK )
	{
		m_move.sq2 = square + 9;
		if ( square >> 3 == 6 ) m_move.special = NEW_QUEEN;
		else m_move.special = NOTHING;
		m_move.o_value =  m_board[m_move.sq2]->value - Q_PAWN;
		m_move.valid = true;
		m_currentStack->AddElement(&m_move);
	}

	if ( square >> 3 == 6 && m_board[square + 8] == m_pieceList[32] )
	{
		m_move.sq2 = square + 8;
		m_move.special = NEW_QUEEN;
		m_move.valid = true;
		m_move.o_value =  Q_QUEEN - Q_PAWN;
		m_currentStack->AddElement(&m_move);
	}
}

// Atomic Features (Pawn)
// ----------------------

// Bit		Meaning
// ---		-------
//  0		color of the piece has a material advantage
//  1		color of the piece has a material disadvantage

//	2		pawn is blocked (+8 or -8 move not possible) 

//  		attacked by ...
//	3		pawn
//	4		knight
//	5		bishop
//	6		rook
//	7		queen
//	8		king

// pawn endgame:
//  6		pawn has passed opponents king
//  7		opponents king is nearer to pawn than the own king	

//  9		...

//			covered by...
//	10		pawn
//	11		knight
//	12		bishop
//	13		rook
//	14		queen
//	15		king

// pawn endgame:
// 13		own king is in front of the pawn
// 14		opponents king is in front of the pawn

// 16		its the opponents turn to make a move
// ---		---------
// 17		own pawn is on the same column as this pawn
// 18		no opponents pawn on the same column
// 19		no opponents pawn on a neighbouring line
// 20		at least one own pawn on a "lower" neighbouring column
// 21		at least one own pawn on an "upper" neighbouring column
// 22-27	position of the pawn (rank)				
// 28-31	position of the pawn (column) 

const unsigned int pawnRow[64] = {
	0, 0, 0, 0, 0, 0, 0, 0 , 
	BIT_28, BIT_29, BIT_30, BIT_31, BIT_31, BIT_30, BIT_29, BIT_28, 
	BIT_28, BIT_29, BIT_30, BIT_31, BIT_31, BIT_30, BIT_29, BIT_28, 
	BIT_28, BIT_29, BIT_30, BIT_31, BIT_31, BIT_30, BIT_29, BIT_28, 
	BIT_28, BIT_29, BIT_30, BIT_31, BIT_31, BIT_30, BIT_29, BIT_28, 
	BIT_28, BIT_29, BIT_30, BIT_31, BIT_31, BIT_30, BIT_29, BIT_28, 
	BIT_28, BIT_29, BIT_30, BIT_31, BIT_31, BIT_30, BIT_29, BIT_28, 
	0, 0, 0, 0, 0, 0, 0, 0 };

const unsigned int wPawnColumn[64] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	BIT_22, BIT_22, BIT_22, BIT_22, BIT_22, BIT_22, BIT_22, BIT_22, 
	BIT_23, BIT_23, BIT_23, BIT_23, BIT_23, BIT_23, BIT_23, BIT_23, 
	BIT_24, BIT_24, BIT_24, BIT_24, BIT_24, BIT_24, BIT_24, BIT_24, 
	BIT_25, BIT_25, BIT_25, BIT_25, BIT_25, BIT_25, BIT_25, BIT_25, 
	BIT_26, BIT_26, BIT_26, BIT_26, BIT_26, BIT_26, BIT_26, BIT_26, 
	BIT_27, BIT_27, BIT_27, BIT_27, BIT_27, BIT_27, BIT_27, BIT_27, 
	0, 0, 0, 0, 0, 0, 0, 0};

const int wPawnDistance[8] = {0,5,5,4,3,2,1,0};

void WPawn::evaluateAtomics()
{
	//------------------------------------------------------------------------------
	// Bits 2 - 15 (cover, attack)
	//------------------------------------------------------------------------------
	if ( (square & 7) != 0 )
	{
		if ( m_board[square + 7]->color == BLACK )
			m_board[square + 7]->atomics |= BIT_3;
		else if ( m_board[square + 7]->color == WHITE )
			m_board[square + 7]->atomics |= BIT_10;
	}

	if ( (square & 7) != 7 )
	{
		if ( m_board[square + 9]->color == BLACK )
			m_board[square + 9]->atomics |= BIT_3;
		else if ( m_board[square + 9]->color == WHITE )
			m_board[square + 9]->atomics |= BIT_10;
	}

	if ( m_board[square + 8] != m_pieceList[32] ) atomics |= BIT_2;

	//------------------------------------------------------------------------------
	// Bits 16 - 31 (piece specific)
	//------------------------------------------------------------------------------
int column = (square & 7) + 1;
	if ( m_wPawnColumns[column] != 0 ) atomics |= BIT_17;
	if ( m_bPawnColumns[column] == 0 ) atomics |= BIT_18;
	if ( m_bPawnColumns[column - 1] == 0 && 
		 m_bPawnColumns[column + 1] == 0 ) atomics |= BIT_19;
	if ( m_wPawnColumns[column - 1] != 0 ) atomics |= BIT_20;
	if ( m_wPawnColumns[column + 1] != 0 ) atomics |= BIT_21;
	
	atomics |= pawnRow[square];
	atomics |= wPawnColumn[square];

	// evaluate promotion field
	if ( m_pawnEndgame )
	{
	int row, king, dx, dy, d2, d3;
		column = square & 7;
		row = square >> 3;

		king = m_pKing[!color]->square;
		dx = 7 - (king >> 3);
		dy = abs(column - (king & 7)); 
		d2 = (dx > dy ? dx : dy);
		if ( atomics & BIT_16 ) d2--; // its the opponents turn

		if ( d2 > wPawnDistance[row] ) atomics |= BIT_6;
		if ( (king >> 3) > row ) atomics |= BIT_13;

		king = m_pKing[color]->square;
		dx = 7 - (king >> 3);
		dy = abs(column - (king & 7));
		d3 = (dx > dy ? dx : dy);
		
		if ( d2 < wPawnDistance[row] && d2 < d3 ) atomics |= BIT_7; 
		if ( (king >> 3) < row ) atomics |= BIT_14;
	}
}

const unsigned int bPawnColumn[64] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	BIT_27, BIT_27, BIT_27, BIT_27, BIT_27, BIT_27, BIT_27, BIT_27, 
	BIT_26, BIT_26, BIT_26, BIT_26, BIT_26, BIT_26, BIT_26, BIT_26,
	BIT_25, BIT_25, BIT_25, BIT_25, BIT_25, BIT_25, BIT_25, BIT_25, 
	BIT_24, BIT_24, BIT_24, BIT_24, BIT_24, BIT_24, BIT_24, BIT_24, 
	BIT_23, BIT_23, BIT_23, BIT_23, BIT_23, BIT_23, BIT_23, BIT_23, 
	BIT_22, BIT_22, BIT_22, BIT_22, BIT_22, BIT_22, BIT_22, BIT_22, 
	0, 0, 0, 0, 0, 0, 0, 0};

const int bPawnDistance[8] = {0,1,2,3,4,5,5,0};

void BPawn::evaluateAtomics()
{
	//------------------------------------------------------------------------------
	// Bits 2 - 15 (cover, attack)
	//------------------------------------------------------------------------------
	if ( (square & 7) != 7 )
	{
		if ( m_board[square - 7]->color == WHITE )
			m_board[square - 7]->atomics |= BIT_3;
		else if ( m_board[square - 7]->color == BLACK )
			m_board[square - 7]->atomics |= BIT_10;
	}

	if ( (square & 7) != 0 )
	{
		if ( m_board[square - 9]->color == WHITE )
			m_board[square - 9]->atomics |= BIT_3;
		else if ( m_board[square - 9]->color == BLACK )
			m_board[square - 9]->atomics |= BIT_10;
	}

	if ( m_board[square - 8] != m_pieceList[32] ) atomics |= BIT_2;

	//------------------------------------------------------------------------------
	// Bits 16 - 31 (piece specific)
	//------------------------------------------------------------------------------
int column = (square & 7) + 1;
	if ( m_bPawnColumns[column] != 0 ) atomics |= BIT_17;
	if ( m_wPawnColumns[column] == 0 ) atomics |= BIT_18;
	if ( m_wPawnColumns[column + 1] == 0 && 
		 m_wPawnColumns[column - 1] == 0 ) atomics |= BIT_19;
	if ( m_bPawnColumns[column - 1] != 0 ) atomics |= BIT_20;
	if ( m_bPawnColumns[column + 1] != 0 ) atomics |= BIT_21;

	atomics |= pawnRow[square];
	atomics |= bPawnColumn[square];

	// evaluate promotion field
	if ( m_pawnEndgame )
	{
	int row, king, dx, dy, d2, d3;
		column = square & 7;
		row = square >> 3;

		king = m_pKing[!color]->square;
		dx = king >> 3;
		dy = abs(column - (king & 7)); 
		d2 = (dx > dy ? dx : dy);
		if ( atomics & BIT_16 ) d2--; // its the opponents turn

		if ( d2 > bPawnDistance[row] ) atomics |= BIT_6;
		if ( (king >> 3) < row ) atomics |= BIT_13;

		king = m_pKing[color]->square;
		dx = king >> 3;
		dy = abs(column - (king & 7));
		d3 = (dx > dy ? dx : dy);
		
		if ( d2 < bPawnDistance[row] && d2 < d3 ) atomics |= BIT_7; 
		if ( (king >> 3) > row ) atomics |= BIT_14;
	}
}



//----------------------------------------------------------------------------
//		KNIGHT
//----------------------------------------------------------------------------

Knight::Knight(int _color, int _square, int _number, Piece* copy)
{
	hashtype = 3;
	init(_color, _square, _number, copy);	

	possibleMoves = knightMoves;
	type = KNIGHT;
	value = Q_KNIGHT;
	drawValue = DRAW_VALUE_KNIGHT;
}

void Knight::verifyMove()
{
int dx = (square & 7) - (m_move.sq2 & 7);
int dy = (square >> 3) - (m_move.sq2 >> 3);
	m_move.special = NOTHING;

	if ( m_board[m_move.sq2]->color == color ||
		 dx * dx + dy * dy != 5 )
		m_move.valid = false;
	else
		m_move.valid = true;
}

int Knight::generateMoves()
{
int count = 0;
const int* vs = knightMoves;
	m_move.sq1 = square;

	do
	{
		m_move.sq2 = tDown[tUp[square] + (*vs)];
		vs++;
		
		if ( m_move.sq2 != NO_SQUARE )
		{
			m_move.special = NOTHING;

			if ( m_board[m_move.sq2] == m_pieceList[32] )
			{
				m_currentStack->AddElement(&m_move);
				count++;
			}
			else if ( m_board[m_move.sq2]->color == color )
			{
			}
			else
			{
				m_currentStack->AddElement(&m_move);
				count++;
			}
		}
	} while ((*vs) != NO_SQUARE);

	return count;
}

void Knight::generateXMoves()
{
	m_move.sq1 = square;
	const int* vs = possibleMoves;

	while ( (*vs) != NO_SQUARE )
	{
		m_move.sq2 = tDown[tUp[square] + (*vs)];
		vs++;

		if ( m_move.sq2 != NO_SQUARE && (color + m_board[m_move.sq2]->color) == 1)
		{
			m_move.special = NOTHING;
			m_move.valid = true; 
			m_move.o_value = m_board[m_move.sq2]->value - value;
			m_currentStack->AddElement(&m_move);
		}
	}
}


// Atomic Features (Knight)
// ------------------------

// Bit		Meaning
// ---		-------
//  0		color of the piece has a material advantage
//  1		color of the piece has a material disadvantage

//	2		...

//  3-8		attacked by ... (see pawn)

//	9		...

//  10-15	covered by ... (see pawn)

// 16		its the opponents turn to make a move
// ---		---------
// 17-19	distance to the next corner	
// 20		knight can reach at least one field "near" the own king
// 21		knight is placed on the opponents board side
// 22		knight is placed at the border of the board
// 23		...
// 24		knight can reach one field "near" the opponents king
// 25		knight can reach two or more fields "near" the opponents king
// 26-31	distance to the center

void Knight::evaluateAtomics()
{
	//------------------------------------------------------------------------------
	// Bits 2 - 15 (cover, attack)
	//------------------------------------------------------------------------------
const int* vs = knightMoves;
int to;
int kingFields = 0;

	do
	{
		to = tDown[tUp[square] + (*vs)];
		vs++;
		
		if ( to != NO_SQUARE )
		{
			if ( m_board[to] == m_pieceList[32] ) 
			{ 
				if ( m_opKingFields[to] ) kingFields++;
				if ( m_owKingFields[to] ) atomics |= BIT_20;
			}
			else if ( m_board[to]->color == color ) 
			{ 
				m_board[to]->atomics |= BIT_11;
			}
			else 
			{
				m_board[to]->atomics |= BIT_4;
			}
		}
	} while ((*vs) != NO_SQUARE);

	//------------------------------------------------------------------------------
	// Bits 16 - 31 (piece specific)
	//------------------------------------------------------------------------------

	if ( color == WHITE && (square >> 3) >= 4 ) atomics |= BIT_21;
	else if ( color == BLACK && (square >> 3) <= 3 ) atomics |= BIT_21;

	if ( (square & 7) == 0 || (square & 7) == 7 ) atomics |= BIT_22;

	// KBNK patch
	//atomics |= kbnkRow[square];
	//atomics |= kbnkColumn[square];
	atomics |= centerDistance[square];
	atomics |= cornerDistance[square];

	if ( kingFields == 1 ) atomics |= BIT_24;
	else if ( kingFields >= 2 ) atomics |= BIT_25;
}


//----------------------------------------------------------------------------
//		BISHOP
//----------------------------------------------------------------------------

Bishop::Bishop(int _color, int _square, int _number, Piece* copy)
{
	hashtype = 2;
	init(_color, _square, _number, copy);

	possibleMoves = bishopMoves;
	type = BISHOP;
	value = Q_BISHOP;
	drawValue = DRAW_VALUE_BISHOP;
}

// Atomic Features (Bishop)
// ------------------------

// Bit		Meaning
// ---		-------
//  0		color of the piece has a material advantage
//  1		color of the piece has a material disadvantage

//	2		...

//  3-8		attacked by ... (see pawn)

//	9		...

//  10-15	covered by ... (see pawn)

// 16		its the opponents turn to make a move
// ---		---------
// 17-19	distance to the next corner	
// 20		bishop can reach at least one field "near" the own king
// 21		bishop is placed on the opponents board side
// 22		bishop is placed at the border of the board
// 23		...
// 24		bishop can reach one field "near" the opponents king
// 25		bishop can reach two or more fields "near" the opponents king
// 26-31	distance to the center


//const int cornerColor[64] = {
//	0, 0, 0, 0, 1, 1, 1, 1, 
//	0, 0, 0, 0, 1, 1, 1, 1, 
//	0, 0, 0, 0, 1, 1, 1, 1, 
//	0, 0, 0, 0, 1, 1, 1, 1, 
//	1, 1, 1, 1, 0, 0, 0, 0, 
//	1, 1, 1, 1, 0, 0, 0, 0, 
//	1, 1, 1, 1, 0, 0, 0, 0, 
//	1, 1, 1, 1, 0, 0, 0, 0};

void Bishop::evaluateAtomics()
{
	//------------------------------------------------------------------------------
	// Bits 2 - 15 (cover, attack)
	//------------------------------------------------------------------------------
const int* direction = possibleMoves;
int to = square;
int kingFields = 0;

	do
	{
		to = tDown[tUp[to] + (*direction)];

		if ( to != NO_SQUARE ) 
		{
			if ( m_board[to] == m_pieceList[32] ) // empty square
			{
				if ( m_opKingFields[to] ) kingFields++;
				if ( m_owKingFields[to] ) atomics |= BIT_20;
			}
			else if ( m_board[to]->color != color )  // attack
			{
				m_board[to]->atomics |= BIT_5; 
				direction++;
				to = square;
			}
			else // cover
			{
				m_board[to]->atomics |= BIT_12;
				direction++;
				to = square;
			}
		}
		else
		{
			direction++;
			to = square;
		}
	} while ( (*direction) != NO_SQUARE );

	//------------------------------------------------------------------------------
	// Bits 16 - 31 (piece specific)
	//------------------------------------------------------------------------------

	if ( color == WHITE && (square >> 3) >= 4 ) atomics |= BIT_21;
	else if ( color == BLACK && (square >> 3) <= 3 ) atomics |= BIT_21;

	if ( (square & 7) == 0 || (square & 7) == 7 ) atomics |= BIT_22;

	// KBNK patch
	//atomics |= kbnkRow[square];
	//atomics |= kbnkColumn[square];
	atomics |= centerDistance[square];
	atomics |= cornerDistance[square];

	if ( kingFields == 1 ) atomics |= BIT_24;
	else if ( kingFields >= 2 ) atomics |= BIT_25;
}


//----------------------------------------------------------------------------
//		ROOK
//----------------------------------------------------------------------------

Rook::Rook(int _color, int _square, int _number, Piece* copy)
{
	hashtype = 1;
	init(_color, _square, _number, copy);
	
	possibleMoves = rookMoves;
	type = ROOK;
	value = Q_ROOK;
	drawValue = DRAW_VALUE_ROOK;
}


// Atomic Features (Rook)
// ----------------------

// Bit		Meaning
// ---		-------
//  0		color of the piece has a material advantage
//  1		color of the piece has a material disadvantage

//	2		...

//  3-8		attacked by ... (see pawn)

//	9		...

//  10-15	covered by ... (see pawn)

// 16		its the opponents turn to make a move
// ---		---------
// 17-19	distance to the next corner
// 20		rook can reach at least one square "near" the own king
// 21		small column distance to the opponents king
// 22		small rank distance to the opponents king
// 23		...
// 24		rook can reach one field "near" the opponents king
// 25		rook can reach two or more fields "near" the opponents king
// 26-31    distance to the center

// possible additional feature: right for kingside/queenside castling


void Rook::evaluateAtomics()
{
	//------------------------------------------------------------------------------
	// Bits 2 - 15 (cover, attack)
	//------------------------------------------------------------------------------
const int* direction = possibleMoves;
int to = square;
int kingFields = 0;

	do
	{
		to = tDown[tUp[to] + (*direction)];

		if ( to != NO_SQUARE ) 
		{
			if ( m_board[to] == m_pieceList[32] ) // empty square
			{
				if ( m_opKingFields[to] ) kingFields++;
				if ( m_owKingFields[to] ) atomics |= BIT_20;
			}
			else if ( m_board[to]->color != color )  // attack
			{
				m_board[to]->atomics |= BIT_6; 
				direction++;
				to = square;
			}
			else // cover
			{
				m_board[to]->atomics |= BIT_13;
				direction++;
				to = square;
			}
		}
		else
		{
			direction++;
			to = square;
		}
	} while ( (*direction) != NO_SQUARE );

	//------------------------------------------------------------------------------
	// Bits 16 - 31 (piece specific)
	//------------------------------------------------------------------------------

	int king = m_pKing[!color]->square;
	if ( abs( (king & 7) - (square & 7) ) <= 2 ) atomics |= BIT_21;
	if ( abs( (king >> 3) - (square >> 3) ) <= 2 ) atomics |= BIT_22;
	
	atomics |= cornerDistance[square];
	atomics |= centerDistance[square];

	if ( kingFields == 1 ) atomics |= BIT_24;
	else if ( kingFields >= 2 ) atomics |= BIT_25;
}


//----------------------------------------------------------------------------
//		QUEEN
//----------------------------------------------------------------------------

Queen::Queen(int _color, int _square, int _number, Piece* copy)
{
	hashtype = 4;
	init(_color, _square, _number, copy);

	possibleMoves = queenMoves;
	type = QUEEN;
	value = Q_QUEEN;
	drawValue = DRAW_VALUE_QUEEN;
}

void Queen::verifyMove()
{	
	m_move.special = NOTHING;

	if ( (square & 7) == ( m_move.sq2 & 7) || square >> 3 == m_move.sq2 >> 3 )
		straight();
	else
		diagonal();
}


// Atomic Features (Queen)
// -----------------------

// Bit		Meaning
// ---		-------
//  0		color of the piece has a material advantage
//  1		color of the piece has a material disadvantage

//	2		...

//  3-8		attacked by ... (see pawn)

//	9		...

//  10-15	covered by ... (see pawn)

// 16		its the opponents turn to make a move
// ---		---------
// 17-19	distance to the next corner	
// 20		queen can reach at least one square "near" the own king
// 21		small distance to the opponents king
// 22		medium distance to the opponents king
// 23		big distance to the opponents king
// 24		rook can reach one field "near" the opponents king
// 25		rook can reach two or more fields "near" the opponents king
// 26-31    distance to the center

void Queen::evaluateAtomics()
{
	//------------------------------------------------------------------------------
	// Bits 2 - 15 (cover, attack)
	//------------------------------------------------------------------------------
const int* direction = possibleMoves;
int to = square;
int kingFields = 0;

	do
	{
		to = tDown[tUp[to] + (*direction)];

		if ( to != NO_SQUARE ) 
		{
			if ( m_board[to] == m_pieceList[32] ) // empty square
			{
				if ( m_opKingFields[to] ) kingFields++;
				if ( m_owKingFields[to] ) atomics |= BIT_20;
			}
			else if ( m_board[to]->color != color )  // attack
			{
				m_board[to]->atomics |= BIT_7; 
				direction++;
				to = square;
			}
			else // cover
			{
				m_board[to]->atomics |= BIT_14;
				direction++;
				to = square;
			}
		}
		else
		{
			direction++;
			to = square;
		}
	} while ( (*direction) != NO_SQUARE );

	//------------------------------------------------------------------------------
	// Bits 16 - 31 (piece specific)
	//------------------------------------------------------------------------------

	atomics |= cornerDistance[square];
	atomics |= centerDistance[square];

	int opponent = m_pKing[!color]->square;
	int d1 = abs((opponent & 7) - (square & 7));
	int d2 = abs((opponent >> 3) - (square >> 3));
	if ( d2 > d1 ) d1 = d2;

	if ( d1 <= 2 ) atomics |= BIT_21;
	else if ( d1 <= 4 ) atomics |= BIT_22;
	else if ( d1 <= 6 ) atomics |= BIT_23;

	if ( kingFields == 1 ) atomics |= BIT_24;
	else if ( kingFields >= 2 ) atomics |= BIT_25;
}


//----------------------------------------------------------------------------
//		KING
//----------------------------------------------------------------------------

King::King(int _color, int _square, int _number, Piece* copy)
{
	hashtype = 5;
	init(_color, _square, _number, copy);

	possibleMoves = kingMoves;
	type = KING;
	value = Q_KING;
	drawValue = DRAW_VALUE_KING;
	m_bCastled = false;
}

void King::verifyMove()
{
	m_move.special = NOTHING;
	m_move.valid = false;

	switch ( m_move.sq2 - square )
	{

		case 2:
			if ( (square & 7) == 4 &&
				  m_board[square]->moveCount == 0 &&
				  m_board[square + 3]->moveCount == 0 &&
				  m_board[square + 1] == m_pieceList[32] &&
				  m_board[square + 2] == m_pieceList[32] &&
				  m_board[square + 3]->type == ROOK )
			{
				if ( isAttacked() ) return;
				m_move.sq2 = square + 1;

				m_board[m_move.sq2] = m_board[square];
				m_board[square] = m_pieceList[32];
				square++;

				if( !isAttacked() ) 
				{
					m_move.valid = true;
					m_move.special = KING_CASTLING;
				}
				m_board[square - 1] = m_board[square];
				m_board[square] = m_pieceList[32];
				square--;
				
				m_move.sq2 = square + 2;
			}
		return; break;
		case -2:
			if ( (square & 7) == 4 &&
				  m_board[square]->moveCount == 0 &&
				  m_board[square - 4]->moveCount == 0 &&
				  m_board[square - 1] == m_pieceList[32] &&
				  m_board[square - 2] == m_pieceList[32] &&
				  m_board[square - 3] == m_pieceList[32] &&
				  m_board[square - 4]->type == ROOK )
			{
				if ( isAttacked() ) return;
				m_move.sq2 = square - 1;

				m_board[m_move.sq2] = m_board[square];
				m_board[square] = m_pieceList[32];
				square--;

				if( !isAttacked() )
				{
					m_move.valid = true;
					m_move.special = QUEEN_CASTLING;
				}

				m_board[square + 1] = m_board[square];
				m_board[square] = m_pieceList[32];
				square++;

				m_move.sq2 = square - 2;
			}
		return; break;
		case -1: if ( (square & 7) == 0 ) return; break;
		case 1: if ( (square & 7) == 7 ) return; break;
		case 7: if ( (square & 7) == 0 ) return; break;
		case 8: break;
		case 9: if ( (square & 7) == 7 ) return; break;
		case -7: if ( (square & 7) == 7 ) return; break;
		case -8: break;
		case -9: if ( (square & 7) == 0 ) return; break;
		default: return; break;
	}

	if ( !(m_board[m_move.sq2]->color == color) )
		m_move.valid = true;
}

int King::generateMoves()
{
int count = 0;
const int* vs = kingMoves;
	m_move.sq1 = square;

	do
	{
		m_move.sq2 = tDown[tUp[square] + *vs];
		vs++;
		
		if ( m_move.sq2 != NO_SQUARE )
		{
			m_move.special = NOTHING;
			if ( m_board[m_move.sq2] == m_pieceList[32] )
			{
				m_currentStack->AddElement(&m_move);
				count++;
			}
			else if ( m_board[m_move.sq2]->color == color )
			{
			}
			else
			{
				m_currentStack->AddElement(&m_move);
				count++;
			}
		}
	} while ( *vs != NO_SQUARE );

	m_move.sq2 = tDown[tUp[square] + 2];
	if ( m_move.sq2 != NO_SQUARE )
	{
		verifyMove();
		if ( m_move.valid ) 
		{
			m_currentStack->AddElement(&m_move);
			count++;
		}
	}

	m_move.sq2 = tDown[tUp[square] - 2];
	if ( m_move.sq2 != NO_SQUARE )
	{
		verifyMove();
		if ( m_move.valid ) 
		{
			m_currentStack->AddElement(&m_move);
			count++;
		}
	}

	return count;
}

void King::generateXMoves()
{
	m_move.sq1 = square;
	const int* vs = possibleMoves;

	while ( (*vs) != NO_SQUARE ) // castling is not evaluated
	{
		m_move.sq2 = tDown[tUp[square] + (*vs)];
		vs++;

		if ( m_move.sq2 != NO_SQUARE && (color + m_board[m_move.sq2]->color) == 1)
		{
			m_move.special = NOTHING;
			m_move.valid = true;
			m_move.o_value = m_board[m_move.sq2]->value - value;
			m_currentStack->AddElement(&m_move);
		}
	}
}


// Atomic Features (King)
// ----------------------

// Bit		Meaning
// ---		-------
//  0		color of the piece has a material advantage
//  1		color of the piece has a material disadvantage

//	2		king can reach at most one empty square

//  3-7		attacked by ... (see pawn)

//  8		dx == 0 (dx and dy are relative column and rank distances between the two kings)

//	9		...

// 10-14	coverd by ... (see pawn)

// 15		dx == 1 

// 16		its the opponents turn to make a move
// ---		---------
// 17-19	distance to the next corner	
// 20		king covers two ore more pawns
// 21		dx == 2
// 22		dx == 3
// 23		dy == 0
// 24		dy == 1
// 25		dy == 2
// 26		dy == 3
// 27		king has done a castling move
// 28-31	kings position on the board

const unsigned int kingRegions[64] = {
	BIT_28, BIT_28, BIT_28, BIT_28, BIT_28, BIT_28, BIT_28, BIT_28, 
	BIT_28, BIT_29, BIT_29, BIT_29, BIT_29, BIT_29, BIT_29, BIT_28, 
	BIT_28, BIT_29, BIT_30, BIT_30, BIT_30, BIT_30, BIT_29, BIT_28, 
	BIT_28, BIT_29, BIT_30, BIT_31, BIT_31, BIT_30, BIT_29, BIT_28, 
	BIT_28, BIT_29, BIT_30, BIT_31, BIT_31, BIT_30, BIT_29, BIT_28, 
	BIT_28, BIT_29, BIT_30, BIT_30, BIT_30, BIT_30, BIT_29, BIT_28, 
	BIT_28, BIT_29, BIT_29, BIT_29, BIT_29, BIT_29, BIT_29, BIT_28, 
	BIT_28, BIT_28, BIT_28, BIT_28, BIT_28, BIT_28, BIT_28, BIT_28};

void King::evaluateAtomics()
{
	//------------------------------------------------------------------------------
	// Bits 2 - 15 (cover, attack)
	//------------------------------------------------------------------------------
const int* vs = kingMoves;
int to;
int pawnCount = 0;
int emptyCount = 0;

	do
	{
		to = tDown[tUp[square] + *vs];
		vs++;
		
		if ( to != NO_SQUARE )
		{
			if ( m_board[to] == m_pieceList[32] )
			{
				m_owKingFields[to] = true;
				emptyCount++;
			}
			else if ( m_board[to]->color == color ) // cover
			{
				m_board[to]->atomics |= BIT_15; 
				if ( m_board[to]->type == PAWN ) pawnCount++;
			}
			else // attack
			{
				m_board[to]->atomics |= BIT_8; 
			}
		}
	} while ( *vs != NO_SQUARE );

	//------------------------------------------------------------------------------
	// Bits 16 - 31 (piece specific)
	//------------------------------------------------------------------------------

	if ( pawnCount >= 2 ) atomics |= BIT_20; 
	if ( emptyCount <= 1 ) atomics |= BIT_2;

	// KBNK patch
	//atomics |= kbnkRow[square];
	//atomics |= kbnkColumn[square];
	atomics |= kingRegions[square]; 
	atomics |= cornerDistance[square];

	if ( m_bCastled ) atomics |= BIT_27; 
}

